diff --git a/gnu/local.mk b/gnu/local.mk
index 50b11a8ca2..94f468e743 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -38,7 +38,7 @@
 # Copyright © 2020 Tanguy Le Carrour <tanguy@bioneland.org>
 # Copyright © 2020 Martin Becze <mjbecze@riseup.net>
 # Copyright © 2020 Malte Frank Gerdes <mate.f.gerdes@gmail.com>
-# Copyright © 2020 Vinicius Monego <monego@posteo.net>
+# Copyright © 2020, 2021 Vinicius Monego <monego@posteo.net>
 # Copyright © 2021 Björn Höfling <bjoern.hoefling@bjoernhoefling.de>
 # Copyright © 2021 Philip McGrath <philip@philipmcgrath.com>
 #
@@ -518,6 +518,7 @@ GNU_SYSTEM_MODULES =				\
   %D%/packages/speech.scm			\
   %D%/packages/sphinx.scm			\
   %D%/packages/spice.scm			\
+  %D%/packages/spyder.scm			\
   %D%/packages/sqlite.scm			\
   %D%/packages/squirrel.scm			\
   %D%/packages/ssh.scm				\
diff --git a/gnu/packages/spyder.scm b/gnu/packages/spyder.scm
new file mode 100644
index 0000000000..9983066803
--- /dev/null
+++ b/gnu/packages/spyder.scm
@@ -0,0 +1,90 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright © 2021 Vinicius Monego <monego@posteo.net>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (gnu packages spyder)
+  #:use-module ((guix licenses) #:prefix license:)
+  #:use-module (guix build-system python)
+  #:use-module (guix git-download)
+  #:use-module (guix packages)
+  #:use-module (gnu packages)
+  #:use-module (gnu packages check)
+  #:use-module (gnu packages python)
+  #:use-module (gnu packages python-science)
+  #:use-module (gnu packages python-xyz))
+
+(define-public python-spyder-kernels
+  (package
+    (name "python-spyder-kernels")
+    (version "2.0.1")
+    (source
+     (origin
+       ;; There are no tests in the PyPI tarball.
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/spyder-ide/spyder-kernels/")
+             (commit (string-append "v" version))))
+       (file-name (git-file-name name version))
+       (sha256
+        (base32 "0lxa2s577dd3v8gslk7nzk5ck42gbnqa52dp9cw852n8rv988g4c"))))
+    (build-system python-build-system)
+    (arguments
+     `(#:test-target "pytest"
+       #:phases
+       (modify-phases %standard-phases
+         ;; Tests require write permission.
+         (add-before 'check 'change-home
+           (lambda _
+             (setenv "HOME" "/tmp")
+             #t))
+         (replace 'check
+           (lambda _
+             ;; Disable failing tests.
+             (invoke "python" "-m" "pytest" "-k"
+                     (string-append "not test_cwd_in_sys_path"
+                                    " and not test_dask_multiprocessing"
+                                    " and not test_runfile"
+                                    " and not test_umr_reload_modules")))))))
+    (propagated-inputs
+     `(("python-cloudpickle" ,python-cloudpickle)
+       ("python-decorator" ,python-decorator)
+       ("python-ipykernel" ,python-ipykernel)
+       ("python-ipython" ,python-ipython)
+       ("python-jupyter-client" ,python-jupyter-client)
+       ("python-pyzmq" ,python-pyzmq)
+       ("python-wurlitzer" ,python-wurlitzer)))
+    (native-inputs
+     `(("python-codecov" ,python-codecov)
+       ("python-cython" ,python-cython)
+       ("python-dask" ,python-dask)
+       ("python-flaky" ,python-flaky)
+       ("python-matplotlib" ,python-matplotlib)
+       ("python-mock" ,python-mock)
+       ("python-numpy" ,python-numpy)
+       ("python-pandas" ,python-pandas)
+       ("python-pillow" ,python-pillow)
+       ("python-pytest" ,python-pytest)
+       ("python-pytest-cov" ,python-pytest-cov)
+       ("python-pytest-runner" ,python-pytest-runner)
+       ("python-scipy" ,python-scipy)
+       ("python-xarray" ,python-xarray)))
+    (home-page "https://github.com/spyder-ide/spyder-kernels")
+    (synopsis "Jupyter kernels for Spyder's console")
+    (description
+     "This package provides Jupyter kernels for use with the consoles of
+Spyder, the Scientific Python Development Environment.")
+    (license license:expat)))